.AUTODEPEND

#		*Translator Definitions*
CC = bcc +MIDRESET.CFG
TASM = TASM
TLIB = tlib
TLINK = tlink
LIBPATH = D:\BORLANDC\LIB
INCLUDEPATH = D:\BORLANDC\INCLUDE


#		*Implicit Rules*
.c.obj:
  $(CC) -c {$< }

.cpp.obj:
  $(CC) -c {$< }

#		*List Macros*


EXE_dependencies =  \
 midreset.obj \
 midiio.obj

#		*Explicit Rules*
midreset.exe: midreset.cfg $(EXE_dependencies)
  $(TLINK) /v/x/c/P-/L$(LIBPATH) @&&|
c0s.obj+
midreset.obj+
midiio.obj
midreset
		# no map file
cs.lib
|


#		*Individual File Dependencies*
midreset.obj: midreset.cfg midreset.cpp 

midiio.obj: midreset.cfg midiio.cpp 

#		*Compiler Configuration File*
midreset.cfg: midreset.mak
  copy &&|
-f-
-K
-N
-v
-rd
-vi-
-wbbf
-wpin
-wamb
-wamp
-w-par
-wasm
-wpro
-wcln
-wdef
-wsig
-wnod
-wstv
-wucp
-wuse
-weas
-wpre
-I$(INCLUDEPATH)
-L$(LIBPATH)
-DMIDI_BUFSIZE=8192
| midreset.cfg


