#include "progname.h"

const char* gmdrumname = "GM Drums";

const char* gmprogname[GMPROGRAMS] =
{
 "GrandPno",
 "BritePno",
 "El.Grand",
 "HnkyTonk",
 "ElPiano1",
 "ElPiano2",
 "Harpsich",
 "Clavi.",
 "Celesta",
 "Glocken",
 "MusicBox",
 "Vibes",
 "Marimba",
 "Xylophon",
 "TubulBel",
 "Dulcimer",
 "DrawOrgn",
 "PercOrgn",
 "RockOrgn",
 "ChrcOrgn",
 "ReedOrgn",
 "Acordion",
 "Harmnica",
 "TangoAcd",
 "NylonGtr",
 "SteelGtr",
 "Jazz Gtr",
 "CleanGtr",
 "Mute Gtr",
 "Ovrdrive",
 "Distortd",
 "Harmnics",
 "WoodBass",
 "FngrBass",
 "PickBass",
 "Fretless",
 "SlapBas1",
 "SlapBas2",
 "SynBass1",
 "SynBass2",
 "Violin",
 "Viola",
 "Cello",
 "Contra",
 "TremStrg",
 "Pizzicto",
 "Harp",
 "Timpani",
 "Ensmble1",
 "Ensmble2",
 "SynStrg1",
 "SynStrg2",
 "AahChoir",
 "OohChoir",
 "SynChoir",
 "Orch Hit",
 "Trumpet",
 "Trombone",
 "Tuba",
 "MuteTrum",
 "FrenchHr",
 "BrasSect",
 "SynBras1",
 "SynBras2",
 "SprnoSax",
 "Alto Sax",
 "TenorSax",
 "Bari Sax",
 "Oboe",
 "EnglHorn",
 "Bassoon",
 "Clarinet",
 "Piccolo",
 "Flute",
 "Recorder",
 "PanFlute",
 "Bottle",
 "Shakhchi",
 "Whistle",
 "Ocarina",
 "SquareLd",
 "Saw   Ld",
 "CaliopLd",
 "Chiff Ld",
 "CharanLd",
 "Voice Ld",
 "Fifth Ld",
 "Bass &Ld",
 "NewAgePd",
 "Warm  Pd",
 "PolySyPd",
 "Choir Pd",
 "Bowed Pd",
 "Metal Pd",
 "Halo  Pd",
 "Sweep Pd",
 "Rain",
 "SoundTrk",
 "Crystal",
 "Atmosphr",
 "Bright",
 "Goblin",
 "Echoes",
 "SciFi",
 "Sitar",
 "Banjo",
 "Shamisen",
 "Koto",
 "Kalimba",
 "Bagpipe",
 "Fiddle",
 "Shanai",
 "TnklBell",
 "Agogo",
 "Stl Drum",
 "WoodBlok",
 "TaikoDrm",
 "MelodTom",
 "SynthTom",
 "RevCymbl",
 "FretNoiz",
 "BrthNoiz",
 "Seashore",
 "Tweet",
 "Telphone",
 "Helicptr",
 "Applause",
 "Gunshot"
};

MIDIPATCH xgprogname[XGPROGRAMS] =
{
 {   0, 1, "GrndPnoK" },
 {   0, 18, "MelloGrP" },
 {   0, 40, "PianoStr" },
 {   0, 41, "Dream" },
 {   1, 1, "BritPnoK" },
 {   2, 1, "ElGrPnoK" },
 {   2, 32, "Det.CP80" },
 {   2, 40, "ElGrPno1" },
 {   2, 41, "ElGrPno2" },
 {   3, 1, "HnkyTnkK" },
 {   4, 1, "El.Pno1K" },
 {   4, 18, "MelloEP1" },
 {   4, 32, "Chor.EP1" },
 {   4, 40, "HardEl.P" },
 {   4, 45, "VXElP1" },
 {   4, 64, "60sEl.P" },
 {   5, 1, "El.Pno2K" },
 {   5, 32, "Chor.EP2" },
 {   5, 33, "DX.Hard" },
 {   5, 34, "DXLegend" },
 {   5, 40, "DXPhase" },
 {   5, 41, "DX+Analg" },
 {   5, 42, "DXKotoEP" },
 {   5, 45, "VXEl.P2" },
 {   6, 1, "Harpsi.K" },
 {   6, 25, "Harpsi.2" },
 {   6, 35, "Harpsi.3" },
 {   7, 1, "Clavi.K" },
 {   7, 27, "ClaviWah" },
 {   7, 64, "PulseClv" },
 {   7, 65, "PierceCl" },
 {  10, 64, "Orgel" },
 {  11, 1, "VibesK" },
 {  11, 45, "HardVibe" },
 {  12, 1, "MarimbaK" },
 {  12, 64, "SineMrmb" },
 {  12, 97, "Balafon2" },
 {  12, 98, "LogDrum" },
 {  14, 96, "ChrchBel" },
 {  14, 97, "Carillon" },
 {  15, 35, "Dulcimr2" },
 {  15, 96, "Cimbalom" },
 {  15, 97, "Santur" },
 {  16, 32, "DelDrwOr" },
 {  16, 33, "60sDrOr1" },
 {  16, 34, "60sDrOr2" },
 {  16, 35, "70sDrOr1" },
 {  16, 36, "DrawOrg2" },
 {  16, 37, "60sDrOr3" },
 {  16, 38, "EvenBar" },
 {  16, 40, "16+2\"2/3" },
 {  16, 64, "OrganBa" },
 {  16, 65, "70sDrOr2" },
 {  16, 66, "CheezOrg" },
 {  16, 67, "DrawOrg3" },
 {  17, 24, "70sPcOr1" },
 {  17, 32, "DetPrcOr" },
 {  17, 33, "LiteOrg" },
 {  17, 37, "PercOrg2" },
 {  18, 64, "RotaryOr" },
 {  18, 65, "SloRotar" },
 {  18, 66, "FstRotar" },
 {  19, 32, "ChurOrg3" },
 {  19, 35, "ChurOrg2" },
 {  19, 40, "NotreDam" },
 {  19, 64, "OrgFlute" },
 {  19, 65, "TrmOrgFl" },
 {  20, 40, "PuffOrg" },
 {  21, 32, "Accordlt" },
 {  22, 32, "Harmo2" },
 {  23, 64, "TngoAcd2" },
 {  24, 16, "NylonGt2" },
 {  24, 25, "NylonGt3" },
 {  24, 43, "VelGtHrm" },
 {  24, 96, "Ukelele" },
 {  25, 16, "SteelGt2" },
 {  25, 35, "12StrGtr" },
 {  25, 40, "Nylon&Stl" },
 {  25, 41, "Stl&Body" },
 {  25, 96, "Mandolin" },
 {  26, 18, "MelloGtr" },
 {  26, 32, "JazzAmp" },
 {  27, 32, "ChorusGt" },
 {  28, 40, "FunkGtr1" },
 {  28, 41, "MuteStlG" },
 {  28, 43, "FunkGtr2" },
 {  28, 45, "JazzMan" },
 {  29, 43, "Gt.Pinch" },
 {  30, 40, "FeedbkGt" },
 {  30, 41, "FeedbGt2" },
 {  31, 65, "GtFeedbk" },
 {  31, 66, "GtrHrmo2" },
 {  32, 40, "JazzRthm" },
 {  32, 45, "VXUprght" },
 {  33, 18, "FingrDrk" },
 {  33, 27, "FlangeBa" },
 {  33, 40, "Ba&DstEG" },
 {  33, 43, "FngrSlap" },
 {  33, 45, "FngBass2" },
 {  33, 65, "ModAlem" },
 {  34, 28, "MutePkBa" },
 {  35, 32, "Fretles2" },
 {  35, 33, "Fretles3" },
 {  35, 34, "Fretles4" },
 {  35, 96, "SynFretl" },
 {  35, 97, "Smooth" },
 {  36, 27, "ResoSlap" },
 {  36, 32, "PunchThm" },
 {  37, 43, "VeloSlap" },
 {  38, 18, "SynBa1Dk" },
 {  38, 20, "FastResB" },
 {  38, 24, "AcidBass" },
 {  38, 35, "ClvBass" },
 {  38, 40, "TeknoBa" },
 {  38, 64, "Oscar" },
 {  38, 65, "SqrBass" },
 {  38, 66, "RubberBa" },
 {  38, 96, "Hammer" },
 {  39, 6, "MelloSB1" },
 {  39, 12, "SeqBass" },
 {  39, 18, "ClkSynBa" },
 {  39, 19, "SynBa2Dk" },
 {  39, 32, "SmthBa2" },
 {  39, 40, "ModulrBa" },
 {  39, 41, "DXBass" },
 {  39, 64, "XWireBa" },
 {  40, 8, "SlowVln" },
 {  44, 8, "SlowTrStr" },
 {  44, 40, "SuspStr" },
 {  46, 40, "YangChin" },
 {  48, 3, "S.Strngs" },
 {  48, 8, "SlowStr" },
 {  48, 24, "ArcoStr" },
 {  48, 35, "60sStrng" },
 {  48, 40, "Orchestr" },
 {  48, 41, "Orchstr2" },
 {  48, 42, "TremOrch" },
 {  48, 45, "VeloStr" },
 {  49, 3, "S.SlwStr" },
 {  49, 8, "LegatoSt" },
 {  49, 40, "WarmStr" },
 {  49, 41, "Kingdom" },
 {  49, 64, "70sStr" },
 {  49, 65, "StrEns3" },
 {  50, 27, "ResoStr" },
 {  50, 64, "SynStr4" },
 {  50, 65, "SSStr" },
 {  52, 3, "S.Choir" },
 {  52, 16, "Ch.Aahs2" },
 {  52, 32, "MelChoir" },
 {  52, 40, "ChoirStr" },
 {  54, 40, "SynVox2" },
 {  54, 41, "Choral" },
 {  54, 64, "AnaVoice" },
 {  55, 35, "OrchHit2" },
 {  55, 64, "Impact" },
 {  56, 16, "Trumpet2" },
 {  56, 17, "BriteTrp" },
 {  56, 32, "WarmTrp" },
 {  57, 18, "Trmbone2" },
 {  58, 16, "Tuba2" },
 {  60, 6, "FrHrSolo" },
 {  60, 32, "FrHorn2" },
 {  60, 37, "HornOrch" },
 {  61, 35, "Tp&TbSec" },
 {  61, 40, "BrssSec2" },
 {  61, 41, "HiBrass" },
 {  61, 42, "MelloBrs" },
 {  62, 12, "QuackBr" },
 {  62, 20, "RezSynBr" },
 {  62, 24, "PolyBrss" },
 {  62, 27, "SynBras3" },
 {  62, 32, "JumpBrss" },
 {  62, 45, "AnaVelBr" },
 {  62, 64, "AnaBrss1" },
 {  63, 18, "SoftBrs" },
 {  63, 40, "SynBras4" },
 {  63, 41, "ChoBrss" },
 {  63, 45, "VelBras2" },
 {  63, 64, "AnaBras2" },
 {  65, 40, "SaxSect" },
 {  65, 43, "HyprAlto" },
 {  66, 40, "BrthTnSx" },
 {  66, 41, "SoftTenr" },
 {  66, 64, "TnrSax2" },
 {  80, 6, "Square2" },
 {  80, 8, "LMSquare" },
 {  80, 18, "Hollow" },
 {  80, 19, "Shmoog" },
 {  80, 64, "Mellow" },
 {  80, 65, "SoloSine" },
 {  80, 66, "SineLead" },
 {  81, 6, "Saw2" },
 {  81, 8, "ThickSaw" },
 {  81, 18, "DynaSaw" },
 {  81, 19, "DigiSaw" },
 {  81, 20, "BigLead" },
 {  81, 24, "HeavySyn" },
 {  81, 25, "WaspySyn" },
 {  81, 40, "PulseSaw" },
 {  81, 41, "Dr.Lead" },
 {  81, 45, "VeloLead" },
 {  81, 96, "SeqAna" },
 {  82, 65, "PurePad" },
 {  83, 64, "Rubby" },
 {  84, 64, "DistLead" },
 {  84, 65, "WireLead" },
 {  85, 24, "SynthAah" },
 {  85, 64, "VoxLead" },
 {  86, 35, "BigFive" },
 {  87, 16, "Big&Low" },
 {  87, 64, "Fat&Prky" },
 {  87, 65, "SoftWurl" },
 {  88, 64, "Fantasy2" },
 {  89, 16, "ThickPad" },
 {  89, 17, "SoftPad" },
 {  89, 18, "SinePad" },
 {  89, 64, "HornPad" },
 {  89, 65, "RotarStr" },
 {  90, 64, "PolyPd80" },
 {  90, 65, "ClickPad" },
 {  90, 66, "AnaPad" },
 {  90, 67, "SquarPad" },
 {  91, 64, "Heaven2" },
 {  91, 66, "Itopia" },
 {  91, 67, "CCPad" },
 {  92, 64, "Glacier" },
 {  92, 65, "GlassPad" },
 {  93, 64, "TinePad" },
 {  93, 65, "PanPad" },
 {  95, 20, "Shwimmer" },
 {  95, 27, "Converge" },
 {  95, 64, "PolarPad" },
 {  95, 66, "Celstial" },
 {  96, 45, "ClaviPad" },
 {  96, 64, "HrmoRain" },
 {  96, 65, "AfrcnWnd" },
 {  96, 66, "Caribean" },
 {  97, 27, "Prologue" },
 {  97, 64, "Ancestrl" },
 {  98, 12, "SynDrCmp" },
 {  98, 14, "Popcorn" },
 {  98, 18, "TinyBell" },
 {  98, 35, "RndGlock" },
 {  98, 40, "GlockChi" },
 {  98, 41, "ClearBel" },
 {  98, 42, "ChorBell" },
 {  98, 64, "SynMalet" },
 {  98, 65, "SftCryst" },
 {  98, 66, "LoudGlok" },
 {  98, 67, "XmasBell" },
 {  98, 68, "VibeBell" },
 {  98, 69, "DigiBell" },
 {  98, 70, "AirBells" },
 {  98, 71, "BellHarp" },
 {  98, 72, "Gamelmba" },
 {  99, 18, "WarmAtms" },
 {  99, 19, "HollwRls" },
 {  99, 40, "NylonEP" },
 {  99, 64, "NylnHarp" },
 {  99, 65, "HarpVox" },
 {  99, 66, "AtmosPad" },
 {  99, 67, "Planet" },
 { 100, 64, "FantaBel" },
 { 100, 96, "Smokey" },
 { 101, 64, "GobSyn" },
 { 101, 65, "50sSciFi" },
 { 101, 66, "RingPad" },
 { 101, 67, "Ritual" },
 { 101, 68, "ToHeaven" },
 { 101, 70, "Night" },
 { 101, 71, "Glisten" },
 { 101, 96, "BelChoir" },
 { 102, 8, "EchoPad2" },
 { 102, 14, "EchoPan" },
 { 102, 64, "EchoBell" },
 { 102, 65, "BigPan" },
 { 102, 66, "SynPiano" },
 { 102, 67, "Creation" },
 { 102, 68, "Stardust" },
 { 102, 69, "ResoPan" },
 { 103, 64, "Starz" },
 { 104, 32, "DetSitar" },
 { 104, 35, "Sitar2" },
 { 104, 96, "Tambra" },
 { 104, 97, "Tamboura" },
 { 105, 28, "MuteBnjo" },
 { 105, 96, "Rabab" },
 { 105, 97, "Gopichnt" },
 { 105, 98, "Oud" },
 { 107, 96, "T.Koto" },
 { 107, 97, "Kanoon" },
 { 111, 64, "Shanai2" },
 { 111, 96, "Pungi" },
 { 111, 97, "Hichriki" },
 { 112, 96, "Bonang" },
 { 112, 97, "Gender" },
 { 112, 98, "Gamelan" },
 { 112, 99, "S.Gamlan" },
 { 112, 100, "RamaCym" },
 { 112, 101, "AsianBel" },
 { 114, 97, "GlasPerc" },
 { 114, 98, "ThaiBell" },
 { 115, 96, "Castanet" },
 { 116, 96, "Gr.Cassa" },
 { 117, 64, "MelTom2" },
 { 117, 65, "RealTom" },
 { 117, 66, "RockTom" },
 { 118, 64, "AnaTom" },
 { 118, 65, "ElecPerc" },
 {  30, 12, "DstRthmG" },
 {  61, 14, "SfrzndBr" },
 {  30, 24, "DistGtr2" },
 {  30, 35, "DistGtr3" },
 {  50, 35, "SynStr3" },
 {  30, 36, "PowerGt2" },
 {  30, 37, "PowerGt1" },
 {  30, 38, "Dst.5ths" },
 {  61, 39, "BrssFall" },
 {  30, 43, "RkRythm2" },
 {  30, 45, "RockRthm" },
 {  27, 64, "CleanGt2" },
 {  31, 64, "AcoHarmo" },
 {  33, 64, "JazzBass" },
 {  52, 64, "StrngAah" },
 {  53, 64, "VoiceDoo" },
 {  59, 64, "MuteTrp2" },
 {  75, 64, "PanFlut2" },
 {  82, 64, "VentSyn" },
 { 108, 64, "BigKalim" },
 { 119, 64, "RevCym2" },
 {  52, 65, "MaleAah" },
 {  55, 65, "BrssStab" },
 {  91, 65, "LitePad" },
 {  95, 65, "Sweepy" },
 {  97, 65, "Rave" },
 { 103, 65, "Odyssey" },
 {  55, 66, "DoublHit" },
 {  55, 67, "BrStab80" },
 { 101, 69, "MilkyWay" },
 { 101, 72, "Puffy" },
 {  12, 96, "Balafon" },
 {  26, 96, "PdlSteel" },
 {  28, 96, "Mu.DstGt" },
 {  53, 96, "VoiceHmn" },
 {  56, 96, "FluglHrn" },
 {  71, 96, "BassClar" },
 {  75, 96, "Kawala" },
 { 106, 96, "Tsugaru" },
 { 113, 96, "Atrigane" },
 { 114, 96, "Tablas" },
 { 119, 96, "RevSnar1" },
 { 119, 97, "RevSnar2" },
 { 119, 98, "RevKick1" },
 { 119, 99, "RevConBD" },
 { 119, 100, "RevTom1" },
 { 119, 101, "RevTom2" }
};

MIDIPATCH xgdrumname[XGDRUMS] = 
{
 {   0, 127, "Standard" },
 {   1, 127, "Standrd2" },
 {   8, 127, "Room" },
 {  16, 127, "Rock" },
 {  24, 127, "Electro" },
 {  25, 127, "Analog" },
 {  32, 127, "Jazz" },
 {  40, 127, "Brush" },
 {  48, 127, "Classic" },
 {   0, 126, "SFX1" },
 {   1, 126, "SFX2" },
 {   0, 64, "CuttngNz" },
 {   1, 64, "CuttngNz2" },
 {   3, 64, "StrSlap" },
 {  16, 64, "Fl.KClik" },
 {  32, 64, "Rain" },
 {  33, 64, "Thunder" },
 {  34, 64, "Wind" },
 {  35, 64, "Stream" },
 {  36, 64, "Bubble" },
 {  37, 64, "Feed" },
 {  48, 64, "Dog" },
 {  49, 64, "Horse" },
 {  50, 64, "Bird2" },
 {  54, 64, "Ghost" },
 {  55, 64, "Maou" },
 {  64, 64, "Tel.Dial" },
 {  65, 64, "DoorSqek" },
 {  66, 64, "DoorSlam" },
 {  67, 64, "Scratch" },
 {  68, 64, "Scratch2" },
 {  69, 64, "WindChm" },
 {  70, 64, "Telphon2" },
 {  80, 64, "CarEngin" },
 {  81, 64, "CarStop" },
 {  82, 64, "CarPass" },
 {  83, 64, "CarCrash" },
 {  84, 64, "Siren" },
 {  85, 64, "Train" },
 {  86, 64, "Jetplane" },
 {  87, 64, "Starship" },
 {  88, 64, "Burst" },
 {  89, 64, "Coaster" },
 {  90, 64, "SbMarine" },
 {  96, 64, "Laughing" },
 {  97, 64, "Scream" },
 {  98, 64, "Punch" },
 {  99, 64, "Heart" },
 { 100, 64, "FootStep" },
 { 112, 64, "MchinGun" },
 { 113, 64, "LaserGun" },
 { 114, 64, "Xplosion" },
 { 115, 64, "FireWork" },
 {   2, 64, "DstCutNz" },
 {   4, 64, "B.Slide" },
 {   5, 64, "P.Scrape" },
 {  51, 64, "Kitty" },
 {  52, 64, "Growl" },
 {  53, 64, "Haunted" },
 { 101, 64, "Applaus2" }
};

MIDIPATCH gsprogname[GSPROGRAMS] =
{
 {   0, 8, "  GrndPnoK" },
 {   0, 16, " MelloGrP" },
 {   0, 126, "A-Piano1" },
 {   0, 127, "a.piano1" },
 {   1, 8, "BritPnoK" },
 {   1, 126, "A-Piano2" },
 {   1, 127, "a.piano2" },
 {   2, 1, "ElGrPno1" },
 {   2, 2, "ElGrPno2" },
 {   2, 8, "ElGrPnoK" },
 {   2, 126, "A-Piano3" },
 {   2, 127, "a.piano3" },
 {   3, 8, "HnkyTnkK" },
 {   3, 126, "A-Piano4" },
 {   3, 127, "e.piano1" },
 {   4, 8, "Chor.EP1" },
 {   4, 16, "VX.El.P1" },
 {   4, 24, "60sEl.P" },
 {   4, 25, "HardEl.P" },
 {   4, 26, "MelloEP1" },
 {   4, 32, "El.Pno1K" },
 {   4, 126, "A-Piano6" },
 {   4, 127, "e.piano2" },
 {   5, 8, "Chor.EP2" },
 {   5, 16, "VXEl.P2" },
 {   5, 24, "DXHard" },
 {   5, 32, "El.Pno2K" },
 {   5, 126, "A-Piano6" },
 {   5, 127, "e.piano3" },
 {   6, 8, "Harpsi.3" },
 {   6, 16, "Harpsi.K" },
 {   6, 24, "Harpsi.2" },
 {   6, 126, "A-Piano7" },
 {   6, 127, "e.piano4" },
 {   7, 8, "Clavi.K" },
 {   7, 126, "E-Piano1" },
 {   7, 127, "hnkytnk" },
 {   8, 126, "E-Piano2" },
 {   8, 127, "e.organ1" },
 {   9, 126, "E-Piano3" },
 {   9, 127, "e.organ2" },
 {  10, 126, "A-Guitr1" },
 {  10, 127, "e.organ3" },
 {  11, 1, "HardVibe" },
 {  11, 8, "VibesK" },
 {  11, 126, "A-Guitr2" },
 {  11, 127, "e.organ4" },
 {  12, 8, "MarimbaK" },
 {  12, 17, "Balafon2" },
 {  12, 24, "LogDrum" },
 {  12, 126, "A-Guitr3" },
 {  12, 127, "pipeorg1" },
 {  13, 126, "E-Guitr1" },
 {  13, 127, "pipeorg2" },
 {  14, 8, "ChrchBel" },
 {  14, 9, "Carillon" },
 {  14, 126, "E-Guitr2" },
 {  14, 127, "pipeorg3" },
 {  15, 1, "Dulcimr2" },
 {  15, 8, "Cimbalom" },
 {  15, 126, "Slap-1" },
 {  15, 127, "acordion" },
 {  16, 1, "70sDrOr1" },
 {  16, 8, "DetDrwOr" },
 {  16, 9, "70sDrOr2" },
 {  16, 16, "60sDrOr1" },
 {  16, 17, "60sDrOr2" },
 {  16, 18, "60sDrOr3" },
 {  16, 24, "CheezOrg" },
 {  16, 32, "DrawOrg2" },
 {  16, 33, "EvenBar" },
 {  16, 40, "OrganBa" },
 {  16, 126, "Slap-2" },
 {  16, 127, "harpsi1" },
 {  17, 1, "70sPcOr1" },
 {  17, 8, "DetPrcOr" },
 {  17, 32, "PercOrg2" },
 {  17, 126, "Slap-3" },
 {  17, 127, "harpsi2" },
 {  18, 8, "RotaryOr" },
 {  18, 16, "SloRotar" },
 {  18, 24, "FstRotar" },
 {  18, 126, "Slap-4" },
 {  18, 127, "harpsi3" },
 {  19, 8, "ChurOrg2" },
 {  19, 16, "ChurOrg3" },
 {  19, 24, "OrgFlute" },
 {  19, 32, "TrmOrgFl" },
 {  19, 126, "Slap-5" },
 {  19, 127, "clavi1" },
 {  20, 126, "Slap-6" },
 {  20, 127, "clavi2" },
 {  21, 8, "Accordit" },
 {  21, 126, "Slap-7" },
 {  21, 127, "clavi3" },
 {  22, 1, "Harmo2" },
 {  22, 126, "Slap-8" },
 {  22, 127, "celesta1" },
 {  23, 126, "Finger-1" },
 {  23, 127, "celesta2" },
 {  24, 8, "Ukulele" },
 {  24, 16, "NylonGt3" },
 {  24, 24, "VelGtHrm" },
 {  24, 32, "NylonGt2" },
 {  24, 40, "LequintG" },
 {  24, 126, "Finger-2" },
 {  24, 127, "synbras1" },
 {  25, 8, "12StrGtr" },
 {  25, 9, "Nyln&Stl" },
 {  25, 16, "Mandolin" },
 {  25, 32, "SteelGt2" },
 {  25, 126, "Picked-1" },
 {  25, 127, "synbras2" },
 {  26, 1, "MelloGtr" },
 {  26, 8, "PdlSteel" },
 {  26, 126, "Picked-2" },
 {  26, 127, "synbras3" },
 {  27, 8, "ChorusGt" },
 {  27, 126, "FretlsBs" },
 {  27, 127, "synbras4" },
 {  28, 8, "FunkGtr1" },
 {  28, 16, "FunkGtr2" },
 {  28, 126, "A-Bass" },
 {  28, 127, "synbass1" },
 {  29, 126, "Choir-1" },
 {  29, 127, "synbass2" },
 {  30, 8, "FeedbkGt" },
 {  30, 9, "FeedbGt2" },
 {  30, 126, "Choir-2" },
 {  30, 127, "synbass3" },
 {  31, 8, "GtFeedbk" },
 {  31, 126, "Choir-3" },
 {  31, 127, "synbass4" },
 {  32, 126, "Choir-4" },
 {  32, 127, "newagepd" },
 {  33, 1, "FngBass2" },
 {  33, 126, "Strngs-1" },
 {  33, 127, "synharmo" },
 {  34, 8, "MutePkBa" },
 {  34, 126, "Strngs-2" },
 {  34, 127, "choir pd" },
 {  35, 1, "Fretles2" },
 {  35, 2, "Fretles3" },
 {  35, 3, "Fretles4" },
 {  35, 4, "SynFretl" },
 {  35, 5, "Smooth" },
 {  35, 126, "Strngs-3" },
 {  35, 127, "bowedpd" },
 {  36, 8, "ResoSlap" },
 {  36, 126, "Strngs-4" },
 {  36, 127, "soundtrk" },
 {  37, 126, "E-Organ1" },
 {  37, 127, "atmospgr" },
 {  38, 1, "SynBa1Dk" },
 {  38, 8, "AcidBass" },
 {  38, 9, "FastResB" },
 {  38, 10, "TeknoBa" },
 {  38, 16, "ResoBass" },
 {  38, 126, "E-Organ2" },
 {  38, 127, "synwarm" },
 {  39, 1, "ClkSynBa" },
 {  39, 2, "ModulrBa" },
 {  39, 3, "SeqBass" },
 {  39, 8, "DxBass" },
 {  39, 9, "XWireBa" },
 {  39, 16, "RubberBa" },
 {  39, 17, "SynBa2Dk" },
 {  39, 18, "MelloSB1" },
 {  39, 126, "E-Organ3" },
 {  39, 127, "synfunny" },
 {  40, 8, "SlowVln" },
 {  40, 126, "E-Organ4" },
 {  40, 127, "synecho1" },
 {  41, 126, "E-Organ5" },
 {  41, 127, "rain" },
 {  42, 126, "E-Organ6" },
 {  42, 127, "synoboe" },
 {  43, 126, "E-Organ7" },
 {  43, 127, "synecho2" },
 {  44, 8, "SlowTrStr" },
 {  44, 9, "SuspStr" },
 {  44, 126, "E-Organ8" },
 {  44, 127, "synsolo" },
 {  45, 126, "E-Organ9" },
 {  45, 127, "synrdorg" },
 {  46, 126, "SoftTP-1" },
 {  46, 127, "sunbell" },
 {  47, 126, "SoftTP-2" },
 {  47, 127, "squareld" },
 {  48, 1, "SlowStr" },
 {  48, 8, "Orchestr" },
 {  48, 9, "Orchstr2" },
 {  48, 10, "TermOrch" },
 {  48, 11, "ChoirStr" },
 {  48, 16, "S.Strngs" },
 {  48, 24, "VeloStr" },
 {  48, 126, "TP/TRB-1" },
 {  48, 127, "strsect1" },
 {  49, 1, "70sStr" },
 {  49, 8, "LegatoSt" },
 {  49, 9, "WarmStr" },
 {  49, 10, "S.SlwStr" },
 {  49, 126, "TP/TRB-2" },
 {  49, 127, "strsect2" },
 {  50, 1, "Syn.Str4" },
 {  50, 126, "TP/TRB-3" },
 {  50, 127, "strsect3" },
 {  51, 126, "TP/TRB-4" },
 {  51, 127, "pizz.str" },
 {  52, 8, "S.Choir" },
 {  52, 9, "MelChoir" },
 {  52, 32, "Ch.Aahs2" },
 {  52, 126, "TP/TRB-5" },
 {  52, 127, "violin1" },
 {  53, 126, "TP/TRB-6" },
 {  53, 127, "violin2" },
 {  54, 8, "SynVox2" },
 {  54, 126, "Sax-1" },
 {  54, 127, "cello1" },
 {  55, 1, "OrchHit2" },
 {  55, 8, "Impact" },
 {  55, 16, "LoFiRave" },
 {  55, 126, "Sax-2" },
 {  55, 127, "cello2" },
 {  56, 1, "Trumpet2" },
 {  56, 24, "BriteTrp" },
 {  56, 25, "WarmTrp" },
 {  56, 126, "Sax-3" },
 {  56, 127, "contrabs" },
 {  57, 1, "Trmbone2" },
 {  57, 126, "Sax-4" },
 {  57, 127, "harp1" },
 {  58, 1, "Tuba2" },
 {  58, 126, "Brass-1" },
 {  58, 127, "harp2" },
 {  59, 126, "Brass-2" },
 {  59, 127, "guitar1" },
 {  60, 1, "Frhorn2" },
 {  60, 8, "FrHrSolo" },
 {  60, 16, "HornOrch" },
 {  60, 126, "Brass-3" },
 {  60, 127, "guitar2" },
 {  61, 8, "BrssSec2" },
 {  61, 126, "Brass-4" },
 {  61, 127, "elecgtr1" },
 {  62, 1, "PolyBrss" },
 {  62, 8, "SynBras3" },
 {  62, 9, "QuackBr" },
 {  62, 16, "AnaBrss1" },
 {  62, 126, "Brass-5" },
 {  62, 127, "electgtr2" },
 {  63, 1, "SoftBrs" },
 {  63, 8, "SynBras4" },
 {  63, 16, "AnaBrss2" },
 {  63, 17, "VelBras2" },
 {  63, 126, "Orch-Hit" },
 {  63, 127, "sitar" },
 {  64, 127, "a.bass1" },
 {  65, 8, "HyprAlto" },
 {  65, 127, "a.bass2" },
 {  66, 8, "BrthTnSx" },
 {  66, 127, "e.bass1" },
 {  67, 127, "e.bass2" },
 {  68, 127, "slapbas1" },
 {  69, 127, "slapbas2" },
 {  70, 127, "fretles1" },
 {  71, 127, "fretles2" },
 {  72, 127, "flute1" },
 {  73, 127, "flute2" },
 {  74, 127, "piccolo1" },
 {  75, 127, "piccolo2" },
 {  76, 127, "recorder" },
 {  77, 127, "panpipes" },
 {  78, 127, "sax1" },
 {  79, 127, "sax2" },
 {  80, 1, "Square2" },
 {  80, 2, "Hollow" },
 {  80, 3, "Mellow" },
 {  80, 4, "SoloSine" },
 {  80, 5, "Shmoog" },
 {  80, 6, "LMSquare" },
 {  80, 8, "SineLead" },
 {  80, 127, "sax3" },
 {  81, 1, "Saw2" },
 {  81, 2, "PulseSaw" },
 {  81, 3, "ThickSaw" },
 {  81, 4, "BigLead" },
 {  81, 5, "VeloLead" },
 {  81, 6, "HeavySyn" },
 {  81, 7, "DynaSaw" },
 {  81, 8, "Dr.Lead" },
 {  81, 16, "WaspSyn" },
 {  81, 127, "sax4" },
 {  82, 2, "PurePad" },
 {  82, 127, "clarint1" },
 {  83, 127, "clarint2" },
 {  84, 8, "DistLead" },
 {  84, 127, "oboe" },
 {  85, 127, "eng.horn" },
 {  86, 1, "BigFive" },
 {  86, 127, "basson" },
 {  87, 1, "Big&Low" },
 {  87, 2, "Fat&Prky" },
 {  87, 127, "harmnica" },
 {  88, 1, "Fantasy2" },
 {  88, 127, "trumpet1" },
 {  89, 1, "ThickPad" },
 {  89, 2, "HornPad" },
 {  89, 3, "RotarStr" },
 {  89, 4, "SoftPad" },
 {  89, 127, "trumpet2" },
 {  90, 1, "PolyPd80" },
 {  90, 127, "trmbone1" },
 {  91, 1, "Heaven2" },
 {  91, 127, "trmbone2" },
 {  92, 127, "fr.horn1" },
 {  93, 127, "fr.horn2" },
 {  94, 127, "tuba" },
 {  95, 1, "PolarPad" },
 {  95, 8, "Converge" },
 {  95, 9, "shwimmer" },
 {  95, 10, "Clestial" },
 {  95, 127, "brssect1" },
 {  96, 1, "HrmoRain" },
 {  96, 2, "AfrcnWnd" },
 {  96, 8, "ClaviPad" },
 {  96, 127, "brssect2" },
 {  97, 1, "Ancestrl" },
 {  97, 2, "Prologue" },
 {  97, 127, "vibe1" },
 {  98, 1, "SynMalet" },
 {  98, 2, "SftCryst" },
 {  98, 3, "RndGlock" },
 {  98, 4, "LoudGlok" },
 {  98, 5, "GlockChi" },
 {  98, 6, "ClearBel" },
 {  98, 7, "XmasBell" },
 {  98, 8, "VibeBell" },
 {  98, 9, "DigiBell" },
 {  98, 16, "ChorBell" },
 {  98, 17, "AirBells" },
 {  98, 18, "BellHarp" },
 {  98, 19, "Gamelmba" },
 {  98, 127, "vibe2" },
 {  99, 1, "WarmAtms" },
 {  99, 2, "NylnHarp" },
 {  99, 3, "HarpVox" },
 {  99, 4, "HollwRls" },
 {  99, 5, "NylonEP" },
 {  99, 6, "AtmosPad" },
 {  99, 127, "symallet" },
 { 100, 127, "maletwin" },
 { 101, 1, "GobSyn" },
 { 101, 2, "50sSciFi" },
 { 101, 127, "glocken" },
 { 102, 1, "EchoBell" },
 { 102, 2, "EchoPan" },
 { 102, 3, "EchoPad2" },
 { 102, 4, "BigPan" },
 { 102, 6, "SynPiano" },
 { 102, 127, "tubulbel" },
 { 103, 1, "Starz" },
 { 103, 126, "xylophen" },
 { 104, 1, "Sitar2" },
 { 104, 2, "DetSitar" },
 { 104, 8, "Tambra" },
 { 104, 16, "Tamboura" },
 { 104, 127, "marimba" },
 { 105, 1, "MuteBnjo" },
 { 105, 8, "Rabab" },
 { 105, 16, "Gopichnt" },
 { 105, 24, "Oud" },
 { 105, 127, "koto" },
 { 106, 127, "sho" },
 { 107, 8, "T.Koto" },
 { 107, 16, "Kanoon" },
 { 107, 127, "shakhchi" },
 { 108, 127, "whistle1" },
 { 109, 127, "whistle2" },
 { 110, 127, "bottle" },
 { 111, 1, "Shanai2" },
 { 111, 8, "Pungi" },
 { 111, 16, "Hichriki" },
 { 111, 127, "breath" },
 { 112, 8, "Bonang" },
 { 112, 9, "Gender" },
 { 112, 10, "Gamelan" },
 { 112, 11, "S.Gamlan" },
 { 112, 16, "RamaCym" },
 { 112, 127, "timpani" },
 { 113, 127, "melotom" },
 { 114, 127, "deepsnar" },
 { 115, 8, "Castanet" },
 { 115, 127, "e.perc1" },
 { 116, 8, "Gr.Cassa" },
 { 116, 127, "e.perc1" },
 { 117, 1, "RealTom" },
 { 117, 8, "MelTom2" },
 { 117, 9, "RockTom" },
 { 117, 127, "taiko" },
 { 118, 8, "AnaTom" },
 { 118, 9, "ElecPerc" },
 { 118, 127, "taikorim" },
 { 119, 127, "cymbal" },
 { 120, 1, "CuttngNz" },
 { 120, 2, "StrSlap" },
 { 120, 3, "CttngNz2" },
 { 120, 127, "castanet" },
 { 121, 1, "Fl.KClik" },
 { 121, 127, "triangle" },
 { 122, 1, "Rain" },
 { 122, 2, "Thunder" },
 { 122, 3, "Wind" },
 { 122, 4, "Stream" },
 { 122, 5, "Bubble" },
 { 122, 127, "orchehit" },
 { 123, 1, "Dog" },
 { 123, 2, "Horse" },
 { 123, 3, "Bird2" },
 { 123, 127, "telphone" },
 { 124, 1, "Tel.Dial" },
 { 124, 2, "DoorSqek" },
 { 124, 3, "DoorSlam" },
 { 124, 4, "Scratch" },
 { 124, 5, "WindChm" },
 { 124, 6, "Scratch2" },
 { 124, 127, "bird" },
 { 125, 1, "CarEngin" },
 { 125, 2, "CarStop" },
 { 125, 3, "CarPass" },
 { 125, 4, "CarCrash" },
 { 125, 5, "Siren" },
 { 125, 6, "Train" },
 { 125, 7, "JetPlane" },
 { 125, 8, "Starship" },
 { 125, 9, "Burst" },
 { 125, 16, "Boaster" },
 { 125, 127, "jan" },
 { 126, 1, "Laughing" },
 { 126, 2, "Scream" },
 { 126, 3, "Punch" },
 { 126, 4, "Heart" },
 { 126, 5, "FootStep" },
 { 126, 127, "efctwatr" },
 { 127, 1, "MchinGun" },
 { 127, 2, "LaserGun" },
 { 127, 3, "Xplosion" },
 { 127, 127, "eftjngl" }
};

MIDIPATCH gsdrumname[GSDRUMS] =
{
 {   0, 127, "Standard" },
 {   8, 127, "Room" },
 {  16, 127, "Power" },
 {  24, 127, "Electro" },
 {  25, 127, "Analog" },
 {  32, 127, "Jazz" },
 {  40, 127, "Brush" },
 {  48, 127, "Classic" },
 {  56, 127, "SFX1" },
 {  127, 127, "GM" },
};


const char* mt32progname[MT32PROGRAMS] =
{
 "AcPiano1",
 "AcPiano2",
 "AcPiano3",
 "ElPiano1",
 "ElPiano2",
 "ElPiano3",
 "ElPiano4",
 "Hnkytonk",
 "ElecOrg1",
 "ElecOrg2",
 "ElecOrg3",
 "ElecOrg4",
 "PipeOrg1",
 "PipeOrg2",
 "PipeOrg3",
 "Accrdion",
 "Harpsi 1",
 "Harpsi 2",
 "Harpsi 3",
 "Clavi 1",
 "Clavi 2",
 "Clavi 3",
 "Celesta1",
 "Celesta2",
 "SynBras1",
 "SynBras2",
 "SynBras3",
 "SynBras4",
 "SynBass1",
 "SynBass2",
 "SynBass3",
 "SynBass4",
 "Fantasy",
 "HarmoPan",
 "Chorale",
 "Glasses",
 "Soundtrk",
 "Atmosphr",
 "WarmBell",
 "FunnyVox",
 "EchoBell",
 "Ice Rain",
 "Oboe2001",
 "Echo Pan",
 "Dr. Solo",
 "SchlDaze",
 "Bellsngr",
 "SqreWave",
 "StrSect1",
 "StrSect2",
 "StrSect3",
 "Pizzicto",
 "Violin 1",
 "Violin 2",
 "Cello 1",
 "Cello 2",
 "Contbass",
 "Harp 1",
 "Harp 2",
 "Guitar 1",
 "Guitar 2",
 "ElecGtr1",
 "ElecGtr2",
 "Sitar",
 "AcouBas1",
 "AcouBas2",
 "ElecBas1",
 "ElecBas2",
 "SlapBas1",
 "SlapBas2",
 "Fretles1",
 "Fretles2",
 "Flute 1",
 "Flute 2",
 "Piccolo1",
 "Piccolo2",
 "Recorder",
 "PanPipes",
 "Sax 1",
 "Sax 2",
 "Sax 3",
 "Sax 4",
 "Clarint1",
 "Clarint2",
 "Oboe",
 "EnglHorn",
 "Bassoon",
 "Harmnica",
 "Trumpet1",
 "Trumpet2",
 "Trmbone1",
 "Trmbone2",
 "Fr Horn1",
 "Fr Horn2",
 "Tuba",
 "BrsSect1",
 "BrsSect2",
 "Vibe 1",
 "Vibe 2",
 "SyMallet",
 "Windbell",
 "Glock",
 "TubeBell",
 "Xylophon",
 "Marimba",
 "Koto",
 "Sho",
 "Shakhchi",
 "Whistle1",
 "Whistle2",
 "Bottlebl",
 "Brthpipe",
 "Timpani",
 "MelodTom",
 "DeepSnar",
 "ElecPer1",
 "ElecPer2",
 "Taiko",
 "TaikoRim",
 "Cymbal",
 "Castanet",
 "Triangle",
 "OrcheHit",
 "Telephon",
 "BirdTwt",
 "1NoteJam",
 "WaterBel",
 "JungleTn",
};

int validparams(int channel, int hbank, int lbank, int prog)
{
  if (channel < 0 || channel > 15)
    return 0;
  if (prog < 0 || prog > 127)
    return 0;
  if (hbank < 0 || hbank > 127)
    return 0;
  if (lbank < 0 || lbank > 127)
    return 0;
  return 1;
}

const char* findpatch(MIDIPATCH* table, int count, int bank, int prog)
{
  if (!table)
    return 0;
  for (int i = 0; i < count; i++, table++)
  {
    if (bank == table->bank && prog == table->program)
      return table->patchname;
  }
  return 0;
}

const char* gmpatch(int channel, int hbank, int lbank, int prog)
{
  if (!validparams(channel, hbank, lbank, prog))
    return 0;
  if (channel == 9) // gm drums
    return gmdrumname;
  return gmprogname[prog & 127];
}

const char* gspatch(int channel, int hbank, int lbank, int prog)
{
  if (!validparams(channel, hbank, lbank, prog))
    return 0;
  if (channel == 9) // gm drums
  {
    for (int i = 0; i < GSDRUMS; i++)
    if (prog == gsdrumname[i].program)
      return gsdrumname[i].patchname;
  }
  else
  {
  const char* name = 0;

    if (lbank == 0)
      name = findpatch(gsprogname, GSPROGRAMS, hbank, prog);
    if (name)
      return name;
  }
  return gmpatch(channel, hbank, lbank, prog);
}

const char* xgpatch(int channel, int hbank, int lbank, int prog)
{
const char* name;

  if (!validparams(channel, hbank, lbank, prog))
    return 0;
  if (channel == 9) // gm drums
  {
    name = findpatch(xgdrumname, XGDRUMS, hbank, prog);
    if (name)
      return name;
  }
  else
  {
    name = findpatch(xgprogname, XGPROGRAMS, lbank, prog);
    if (name)
      return name;
    name = findpatch(xgdrumname, XGDRUMS, hbank, prog);
    if (name)
      return name;
  }
  return gmpatch(channel, hbank, lbank, prog);
}

const char* patch(int channel, int hbank, int lbank, int prog, MidiMode mode)
{
  switch(mode)
  {
  case MODE_GS:  return gspatch(channel, hbank, lbank, prog); 
  case MODE_XG:  return xgpatch(channel, hbank, lbank, prog);
  case MODE_GM:
  default:
		 return gmpatch(channel, hbank, lbank, prog);
  }
}
