.AUTODEPEND

#		*Translator Definitions*
CC = bcc +TXT2MIDI.CFG
TASM = TASM
TLIB = tlib
TLINK = tlink
LIBPATH = D:\BORLANDC\LIB
INCLUDEPATH = D:\BORLANDC\INCLUDE


#		*Implicit Rules*
.c.obj:
  $(CC) -c {$< }

.cpp.obj:
  $(CC) -c {$< }

#		*List Macros*
Link_Exclude =  \
 txt2midi.c \
 lexyy.c

Link_Include =  \
 lexyy.obj \
 txt2midi.obj \
 midiread.obj

#		*Explicit Rules*
txt2midi.exe: txt2midi.cfg $(Link_Include) $(Link_Exclude)
  $(TLINK) /v/x/c/P-/L$(LIBPATH) @&&|
c0s.obj+
lexyy.obj+
txt2midi.obj+
midiread.obj
txt2midi
		# no map file
emu.lib+
maths.lib+
cs.lib
|


#		*Individual File Dependencies*
txt2midi.c: txt2midi.cfg txt2midi.y 
	C:\UTIL\BYACC.EXE -v -l -d -b TXT2MIDI TXT2MIDI.Y

lexyy.c: txt2midi.cfg midilex.l 
	C:\UTIL\FLEX.EXE -8 MIDILEX.L

lexyy.obj: txt2midi.cfg lexyy.c 

txt2midi.obj: txt2midi.cfg txt2midi.c 

midiread.obj: txt2midi.cfg midiread.cpp 

#		*Compiler Configuration File*
txt2midi.cfg: txt2midi.mak
  copy &&|
-v
-vi-
-wbbf
-wpin
-wamb
-wamp
-wasm
-wpro
-wcln
-wdef
-w-pia
-wsig
-wnod
-w-rch
-wstv
-wucp
-wuse
-weas
-wpre
-I$(INCLUDEPATH)
-L$(LIBPATH)
-DYY_USE_PROTOS;YYDEBUG=0
-P
| txt2midi.cfg


