.AUTODEPEND

#		*Translator Definitions*
CC = bcc +DMP2MIDI.CFG
TASM = TASM
TLIB = tlib
TLINK = tlink
LIBPATH = D:\BORLANDC\LIB
INCLUDEPATH = D:\BORLANDC\INCLUDE


#		*Implicit Rules*
.c.obj:
  $(CC) -c {$< }

.cpp.obj:
  $(CC) -c {$< }

#		*List Macros*


EXE_dependencies =  \
 dmp2midi.obj \
 midiio.obj

#		*Explicit Rules*
dmp2midi.exe: dmp2midi.cfg $(EXE_dependencies)
  $(TLINK) /v/x/c/P-/L$(LIBPATH) @&&|
c0s.obj+
dmp2midi.obj+
midiio.obj
dmp2midi
		# no map file
emu.lib+
maths.lib+
cs.lib
|


#		*Individual File Dependencies*
dmp2midi.obj: dmp2midi.cfg dmp2midi.cpp 

midiio.obj: dmp2midi.cfg midiio.cpp 

#		*Compiler Configuration File*
dmp2midi.cfg: dmp2midi.mak
  copy &&|
-K
-N
-v
-rd
-vi-
-wbbf
-wpin
-wamb
-wamp
-w-par
-wasm
-wpro
-wcln
-wdef
-wsig
-wnod
-wstv
-wucp
-wuse
-weas
-wpre
-I$(INCLUDEPATH)
-L$(LIBPATH)
| dmp2midi.cfg


