#ifndef __KORGTEXT__
#define __KORGTEXT__

#include <stdio.h>

char key2char(int note);
const char* note2str(int note, int baseoct = 1);
const char* efflev2str(int c, int invers = 0);
const char*multisound2str(int i);
const char* pan2str(int i);
const char* mode2str(int mode, int isvda = 0);
char pm2char(unsigned char b, int which);
const char*onoff2str(int n);
const char*sync2str(int n);
const char* waveform2str(int w);
const char* effect2str(int e);
const char* dmod2str(int d);
const char* group2str(int grp);
const char* tact2str(int tact);
const char* resol2str(int tact);
const char* place2str(int i);
const char* place2str(int prg, int bank);
const char* track2str(int i);
const char* style2str(int i);
const char* kbdassign2str(int i);
const char* trackstat2str(int stat);
const char* chord2str(int type, int );
const char* styelement2str(int i);
const char* chord2str(int c, int tension, int bass, int root);
const char* arr2str(int i);
const char* chordscan2str(int i);
const char* bseqtrack(int i);

const char* time2str(unsigned n, int isloc);
const char* loc2str(unsigned n);
const char* len2str(unsigned n);

void dump( char* c, unsigned len );
void dumpf( FILE* f, unsigned len );

const char* kbdmode(int mode);


#endif
