.AUTODEPEND

#		*Translator Definitions*
CC = bcc +MIDI2TXT.CFG
TASM = TASM
TLIB = tlib
TLINK = tlink
LIBPATH = D:\BORLANDC\LIB
INCLUDEPATH = D:\BORLANDC\INCLUDE


#		*Implicit Rules*
.c.obj:
  $(CC) -c {$< }

.cpp.obj:
  $(CC) -c {$< }

#		*List Macros*


EXE_dependencies =  \
 midi2txt.obj \
 midiio.obj

#		*Explicit Rules*
midi2txt.exe: midi2txt.cfg $(EXE_dependencies)
  $(TLINK) /v/x/c/P-/L$(LIBPATH) @&&|
c0s.obj+
midi2txt.obj+
midiio.obj
midi2txt
		# no map file
emu.lib+
maths.lib+
cs.lib
|


#		*Individual File Dependencies*
midi2txt.obj: midi2txt.cfg midi2txt.cpp 

midiio.obj: midi2txt.cfg midiio.cpp 

#		*Compiler Configuration File*
midi2txt.cfg: midi2txt.mak
  copy &&|
-K
-N
-v
-rd
-vi-
-wbbf
-wpin
-wamb
-wamp
-w-par
-wasm
-wpro
-wcln
-wdef
-wsig
-wnod
-wstv
-wucp
-wuse
-weas
-wpre
-I$(INCLUDEPATH)
-L$(LIBPATH)
-DMIDI_BUFSIZE=8192
| midi2txt.cfg


