.AUTODEPEND

#		*Translator Definitions*
CC = bcc +MIDITRK.CFG
TASM = TASM
TLIB = tlib
TLINK = tlink
LIBPATH = D:\BORLANDC\LIB
INCLUDEPATH = D:\BORLANDC\INCLUDE


#		*Implicit Rules*
.c.obj:
  $(CC) -c {$< }

.cpp.obj:
  $(CC) -c {$< }

#		*List Macros*


EXE_dependencies =  \
 miditrk.obj \
 midiio.obj \
 mtrack.obj \
 progname.obj

#		*Explicit Rules*
miditrk.exe: miditrk.cfg $(EXE_dependencies)
  $(TLINK) /v/s/c/P-/L$(LIBPATH) @&&|
c0s.obj+
miditrk.obj+
midiio.obj+
mtrack.obj+
progname.obj
miditrk,miditrk
graphics.lib+
cs.lib
|


#		*Individual File Dependencies*
miditrk.obj: miditrk.cfg miditrk.cpp 

midiio.obj: miditrk.cfg midiio.cpp 

mtrack.obj: miditrk.cfg mtrack.cpp 

progname.obj: miditrk.cfg progname.cpp 

#		*Compiler Configuration File*
miditrk.cfg: miditrk.mak
  copy &&|
-f-
-K
-N
-v
-rd
-vi-
-wbbf
-wpin
-wamb
-wamp
-w-par
-wasm
-wpro
-wcln
-wdef
-wsig
-wnod
-wstv
-wucp
-wuse
-weas
-wpre
-I$(INCLUDEPATH)
-L$(LIBPATH)
-DMIDI_BUFSIZE=8192
| miditrk.cfg


