#ifndef __SB_H__
#define __SB_H__
#include "sndcard.hpp"

class Soundblaster : public Soundcard
{
public:
  Soundblaster();
  virtual ~Soundblaster();

  static Soundcard* recognize();  // if it is compatible then create soundcard

  virtual int reset();
  virtual void startinput();
  virtual void stopinput();

  virtual int hear(unsigned char* buf, int maxlen);
  virtual int play(unsigned char* buf, int len);

protected:

  static int resetsb();
  static int getsb();

  virtual int getbyte(); // -1 if not available
  virtual int putbyte(unsigned char c); // 0 if error
};

#endif
